c       Non-linear refraction        
c       Theofanis V. Karambas

	write (*,*) 
	write (*,*) 
	write (*,*) '**************************'
	write (*,*) 'Linear wave refraction'        
	write (*,*) '**************************'
	write (*,*) 
	write (*,*) 
	write (*,*) 'period, T=?'
	read (*,*) per
	write (*,*) 'Height, Ho=?'
	read (*,*) Ho
	write (*,*) 'depth, d=?'
	read (*,*) d
	write (*,*) 'incident angle ? (in deg)'
	read (*,*) Ad
	write (*,*) 'bottom slope ? '
	read (*,*) slp



	pi=4.0*atan(1.0)
	A0=(Ad/90)*pi/2.

	omega=2*PI/per

	ALo=9.81*(PER**2)/(2*PI)
	ALNGHP=ALo

	aksi=slp/sqrt(Ho/ALo)
	gamma=aksi**0.17+0.08

   39   AKAPA=2*PI/ALNGHP
	AKD=AKAPA*D
	CH2=COSH(2*AKD)
	s=1/ch2
	SH=SINH(AKD)
	TH=TANH(AKD)
	ALNGH=ALo*TANH(AKD)
	DLEN=ABS(ALNGH-ALNGHP)
	IF (DLEN.GT.0.001) THEN
	ALNGHP=ALNGH
	GOTO 39
	ELSE
	END IF
	CEL=ALNGH/PER
	aL=ALNGH

	an=0.5*(1.+2*AKD/SINH(2*AKD))

	A=ASIN(aL/ALo*SIN(A0))
	write (*,*) 'sina', sin(A)
	aKr=sqrt(cos(A0)/cos(A))
	aKsl=sqrt(0.5*ALo/an/aL)

	H=Ho*aKr*aKsl
	write (*,*)
	write (*,*)
	if (H.gt.gamma*d) then
	write(*,*)'the wave is broken !!!'
	H=gamma*d
	else
	end if

	write (*,*) 
	write (*,*) 'L=',aL
	write (*,*) 
	write (*,*) 'angle=',a*180./pi
	write (*,*)
	write (*,*) 'H=',H
	


	stop
	end

	
